#include <bits/stdc++.h>

using namespace std;

const long long p = 239;
const long long m = (long long)1e9 + 7;
long long h[2][5010], st[5010];
bool dp[5010];

long long mod(long long a)
{
    a %= m;
    if (a < 0)
        a += m;
    return a;
}

long long has(int q, int l, int r)
{
    //cout << "!" << q << " " << l << " " << r << "    " << mod(h[q][r] - h[q][l] * st[r - l]) << endl;
    return mod(h[q][r] - h[q][l] * st[r - l]);
}

int main()
{
    int n;
    string s, t;
    cin >> n >> s >> t;
    st[0] = 1;
    h[0][0] = 0;
    h[1][0] = 0;
    for (int i = 0; i < n; i++)
    {
        h[0][i + 1] = (h[0][i] * p + s[i]) % m;
        h[1][i + 1] = (h[1][i] * p + t[i]) % m;
        st[i + 1] = (st[i] * p) % m;
        //cout << h[0][i + 1] << " " << h[1][i + 1] << " " << st[i + 1] << endl;
    }
    //cout << has(0, 0, 3) << " " << has(1, 8, 11) << endl;
    fill(dp, dp + n + 1, false);
    dp[0] = 1;
    for (int i = 0; i < n; i++)
    {
        if (dp[i])
        {
            for (int j = 1; i + j <= n; j++)
            {
                if (has(0, i, i + j) == has(1, n - i - j, n - i))
                    dp[i + j] = 1;
            }
        }
    }
    if (dp[n])
        cout << "Yes" << endl;
    else
        cout << "No" << endl;
    return 0;
}
