#include <bits/stdc++.h>

using namespace std;

#define ll long long

const int maxN = 100005;

pair<int, int> prs[maxN];

vector<int> edge[maxN];
int cnt[maxN];

int check(int n, int m)
{
    for(int i = 0; i < n; i++) edge[i].clear();
    for(int i = 0; i < n; i++) cnt[i] = 0;

    for(int i = 0; i < m; i++)
    {
        edge[prs[i].first].push_back(prs[i].second);
        cnt[prs[i].second]++;
    }

    int cur = -1;
    for(int i = 0; i < n; i++)
    {
        if(cnt[i] == 0)
        {
            if(cur != -1) return 0;
            cur = i;
        }
    }

    while(cur != -1)
    {
        int nxt = -1;
        for(int v : edge[cur])
        {
            cnt[v]--;
            if(cnt[v] == 0)
            {
                if(nxt != -1) return 0;
                nxt = v;
            }
        }
        cur = nxt;
    }

    return 1;
}

int main()
{
    //freopen("in.in", "r", stdin);

    int n, M;

    cin >> n >> M;
    for(int i = 0; i < M; i++)
    {
        int x, y;
        cin >> x >> y;
        x--; y--;
        prs[i] = make_pair(x, y);
    }

    if(!check(n, M))
    {
        cout << -1 << endl;
        return 0;
    }

    int l = 0, r = M;
    while(r - l > 1)
    {
        int m = (l + r) / 2;
        if(check(n, m)) r = m;
        else l = m;
    }
    cout << r << endl;




    return 0;
}
