import java.io.*;
import java.util.*;

public class I {

	public void dfs(int i) {
		used[i] = true;
		for (int x : h[i]) {
			if (!used[x]) {
				dfs(x);
			}
		}
		a.add(i);
	}

	HashSet<Integer>[] h;
	ArrayList<Integer> a;
	boolean[] used;

	public void solve() throws IOException {
		int n = nextInt();
		int m = nextInt();
		int[] x = new int[m];
		int[] y = new int[m];
		used = new boolean[n];
		for (int i = 0; i < m; i++) {
			x[i] = nextInt() - 1;
			y[i] = nextInt() - 1;
		}
		int l = n - 2;
		int r = m + 1;
		h = new HashSet[n];
		for (int i = 0; i < n; i++) {
			h[i] = new HashSet<>();
		}
		a = new ArrayList<>();
		while (l + 1 < r) {
			int med = (l + r) / 2;
			for (int i = 0; i < n; i++) {
				used[i] = false;
			}
			a.clear();
			for (int i = 0; i < n; i++) {
				h[i].clear();;
			}
			for (int i = 0; i < med; i++) {
				h[x[i]].add(y[i]);
			}
			for (int i = 0; i < n; i++) {
				if (!used[i]) {
					dfs(i);
				}
			}
			boolean flag = true;
			for (int i = 0; i < n - 1; i++) {
				if (h[a.get(i + 1)].contains(a.get(i))) {
					continue;
				}
				flag = false;
				break;
			}
			if (flag) {
				r = med;
			} else {
				l = med;
			}
		}
		if (r > m) {
			out.print(-1);
		} else {
			out.print(r);
		}
	}

	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new I().run();
	}

}
