#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MAX_N = 1e5 + 1;

vector<vector<int> > r(MAX_N);
int n, m;
int kol[MAX_N];
pair<int, int> v[MAX_N];

bool check(int k)
{
    r.clear();
    r.resize(MAX_N);
    unordered_set<int> used;
    memset(kol, 0, sizeof(kol));
    for (int i = 0; i < k; i++)
    {
        r[v[i].first].push_back(v[i].second);
        kol[v[i].second]++;
    }
    int now = -1;
    for (int i = 0; i < n; i++)
        if (kol[i] == 0)
            now = i;
    if (now == -1)
        return false;
    for (int i = 1; i < n - 1; i++)
    {
        int nxt = -1;
        for (int j : r[i])
        {
            kol[j]--;
            if (used.count(j) == 1)
                return false;
            if (kol[j] == 0)
                nxt = j;
        }
        if (nxt == -1)
            return false;
        used.insert(now);
        now = nxt;
    }
    return true;
}

int main()
{
    //freopen("test.in", "r", stdin);
    cin.sync_with_stdio(0);
    cin >> n >> m;
    int l = 0;
    int r = m + 1;
    for (int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--, b--;
        v[i] = (make_pair(a, b));
    }
    while (r - l > 1)
    {
        int h = (l + r) / 2;
        vector<pair<int, int> > now;
        for (int i = 0; i < h; i++)
            now.push_back(v[i]);
        if (check(h))
            r = h;
        else
            l = h;
    }
    if (r == m + 1)
    {
        cout << -1;
        return 0;
    }
    cout << r;
    return 0;
}
