#include <stdio.h>
#include <vector>

using namespace std;

long t;
int n, time;
char direction;
long dir[4][100000];
long in_times[100000];
long out_times[100000];
long ends[4];
long starts[4];
bool ready[4];

int chartodir(char c){
	if (c == 'U'){ return 0; }
	if (c == 'L'){ return 1; }
	if (c == 'D'){ return 2; }
	if (c == 'R'){ return 3; }
}

int max(int x, int y){
	return x < y ? y : x;
}

int min(int x, int y){
	return x > y ? y : x;
}

int min4(int x, int y, int z, int s){
	return min(min(x, y), min(z, s));
}

bool IsiReady(int n,int t){
	bool flag = ((starts[n] < ends[n]) && (in_times[dir[n][starts[n]]] <= t));
	return ((starts[n] < ends[n]) && (in_times[dir[n][starts[n]]] <= t));
}

int main(){
	scanf("%d", &n);
	for (int i = 0; i < n; i++){
		scanf("%d %c", &time, &direction);
		in_times[i] = time;
		dir[chartodir(direction)][ends[chartodir(direction)]] = i;
		ends[chartodir(direction)] += 1;
	}

	t = max(0, min4(in_times[dir[0][ends[0]]], in_times[dir[1][ends[1]]], in_times[dir[2][ends[2]]], in_times[dir[3][ends[3]]]));

	while ((starts[0] < ends[0]) || (starts[1] < ends[1]) || (starts[2] < ends[2]) || (starts[3] < ends[3])){
		for (int z = 0; z < 4; z++) {
			ready[z] = false;
		}
		//   -   
		if (IsiReady(0, t) && IsiReady(1, t) && IsiReady(2, t) && IsiReady(3, t)){
			//  -1
			//printf("%d AZZAZA tut probka\n", t);
			for (int i = 0; i < 4; i++){
				for (int j = starts[i]; j < ends[i]; j++){
					out_times[dir[i][j]] = -1;
				}
			}
			break;
		}
		else{
			for (int i = 0; i < 4; i++){
				ready[i] = ((IsiReady(i, t)) && !IsiReady((i + 1) % 4, t));
			}
			for (int i = 0; i < 4; i++){
				if (ready[i]){
					out_times[dir[i][starts[i]]] = t;
					starts[i] += 1;
				}

			}
		}

		t = max(t + 1, min4(in_times[dir[0][ends[0]]], in_times[dir[1][ends[1]]], in_times[dir[2][ends[2]]], in_times[dir[3][ends[3]]]));
	}

	for (int i = 0; i < n; i++){
		printf("%d\n", out_times[i]);
	}

	return 0;
}