#include <iostream>
#include <fstream>
#include <vector>
using namespace std;

char F[300][300];

int fw, fh, s0;
int  bh, bw, a = 0;

//ifstream cin("tests.txt");
//ofstream cout("tests.out");

struct Point {
	int x = 0;
	int y = 0;
};


Point drop(vector<int> &DB, vector<int> &DF, int shift) {
	//cout << "dropping on " << shift << endl;
	int m = 1000, x;
	int bs = DB.size();
	for (int i = 0; i < bs; i++) {
		x = i + shift;
	
		if (x >= 0 && x < fw) {
		//	cout << x << "|";
        //    cout << "B" << DB[x] << "|" << fw << "|";
		//	cout << "F" << DF[x] << "|" << DF.size() << "|";
		//	cout << endl;
			if (DB[i] + DF[x] < m) {
				m = DB[i] + DF[x];
			}
		}
	}

	Point d = Point();
	d.x = shift;
	d.y = m;
    return d;
}

bool in_F(int x, int y) {
	if (x >= 0 && y >= 0 && x < fw && y < fh) {
		return true;
	}
	else {
		return false;
	}
}

int calc_pts(vector<Point> &B, Point d) {
	//cout << "calc on " << d.x << "," << d.y << endl;
	int x, y, pts = 0, bs = B.size();
	for (int i = 0; i < bs; i++) {
		x = B[i].x + d.x - 1;
		y = B[i].y - bh + d.y;


		//cout << "TRY|" << x << "," << y << "|in:" << in_F(x, y);
		if (in_F(x, y)) {
			if (F[y][x] == '#') {
				//cout << "|is:" << F[y][x];
				pts++;
			}
		} 
		//cout << endl;
	}


	//cout << "CALC:" << pts << endl;
	return pts;
}

int main() {
	bool bs = false;

	vector<Point> B;

    Point point_buff;
	char buff;

	cin >> bh >> bw;

	vector<int> DB(bw, 0);

	for (int i = 0; i < bh; i++) {
		for (int j = 0; j < bw; j++) {
			cin >> buff;
			if (buff == '*') {
				bs = true;
				point_buff = Point();
				point_buff.y = i;
				point_buff.x = j;

				B.push_back(point_buff);
			}
			else if(DB[j] == 0){
				DB[j] = bh - i;
				if (i == 0) {
					if (bs) {
						bw = j;
						DB.resize(bw);
						break;
					}
					else {
						bw--;
						j--;
						DB.resize(bw);
						continue;
					}
				}
			}
		}
	}

//	for (int j = 0; j < bw; j++) {
//		cout << DB[j] << " ";
  //  }

	cin >> fh >> fw;

	int fs = fw - 1;

	vector<int> DF(fw, 0);

	for (int i = 0; i < fh; i++) {
		for (int j = 0; j < fw; j++) {
			cin >> F[i][j];
        }
	}

	for (int i = 0; i < fh; i++) {
		for (int j = 0; j < fw; j++) {
			if (F[i][j] == '.')  {
				DF[j] = i + 1;
				if (i + 1 == fh) {
					if (fs<j) {
						fw = j;
					}
				}
			}
			else {
				if (j < fs) {
					fs = j;
				}
			}
		}
	}

	s0 = fs;

	//cout << endl;

	//cout << "s0:" << s0 << endl;

	//cout << "bw:" << bw << endl;

	//cout << "fw:" << fw << endl;

	//for (int j = 0; j < fw; j++) {
	//	cout << DF[j] << " ";
	//}


	//cout << endl << "---------------------------" << endl;

	int pts;

	for (int i = s0 - bw + 1; i < fw - 1; i++) {
		pts = calc_pts(B, drop(DB, DF, i));
        if (pts > a) {
			a = pts;
		}
	}

	//cout << endl << "---------------------------" << endl;

	cout << a;

	//cin >> buff;
}