n, m = map(int, input().split())
graph = [[] for _ in range(n + 1)]
for i in range(m):
    str = list(map(int, input().split()))
    graph[str[0]].append((i + 1, str[1]))
used = [False] * (n + 1)
left = 0
right = m + 1
mid = (left + right) // 2


def dfs(v):
    used[v] = True
    for to in graph[v]:
        if (to[0] <= mid) and (not used[to[1]]):
            dfs(to[1])


def top(v):
    used[v] = True
    for to in graph[v]:
        if not used[to[1]]:
            top(to[1])
    ans.append(v)


ans = []
for i in range(1, n + 1):
    if not used[i]:
        top(i)
ans = list(reversed(ans))

while left + 1 < right:
    mid = (left + right) // 2
    # used = [False] * (n + 1)
    # dfs(ans[0])
    glflag = 0
    flag = 0
    for i in range(len(ans) - 1):
        flag = 0
        for (numb, to) in graph[ans[i]]:
            if numb <= mid and to == ans[i + 1]:
                flag = 1
        if flag == 0:
            glflag = 1
    if glflag == 0:
        right = mid
    else:
        left = mid
if right == m + 1:
    print(-1)
else:
    print(right)