#include <iostream>
#include <cstdlib>
#include <cmath>
#include <algorithm>

#define ll long long

using namespace std;

const int C = 1000000007, Q = 30, U = 100;

inline ll mem(ll kek1, ll dlin1, ll kek2, ll dlin2)
{
	ll i;
	if (dlin1 < dlin2)
	{
		swap(dlin1, dlin2);
		swap(kek1, kek2);
	}
	for (i = dlin2; i < dlin1; ++i)
		kek2 = (kek2 | (1 << i)) - (1 << i);
	ll s = ((((kek1 ^ kek2) * (1 << dlin1)) % C) * (1 << dlin2)) % C;
	ll t = (1 << dlin1);
	t = ((t * (t - 1)) / 2) % C;
	t = (t * (1 << dlin2)) % C;
	t = (t + s) % C;
	return t;
}

int main()
{
	ll n, z, m, *kek, *dlin, s = 0, ans = 0, i, j;
	cin >> n;
	m = n;
	kek = new ll[U];
	dlin = new ll[U];
	for (z = Q; z >= 0; --z)
	{
		if (m >= (1 << z))
		{
			kek[s] = n - m;
			dlin[s] = z;
			m -= (1 << z);
			++s;
		}
	}
	kek[s] = n;
	dlin[s] = 0;
	++s;
	for (i = 0; i < s; ++i)
	for (j = 0; j < s; ++j)
		ans = (ans + mem(kek[i], dlin[i], kek[j], dlin[j])) % C;
	ans = ((ans - (n * (n + 1)) % C) + C) % C;
	if (ans % 2)
		ans = (ans + C) / 2;
	else
		ans /= 2;
	cout << ans << endl;
	system("pause");
	return 0;
}
/*
4
0 R
0 U
0 L
5 D

7
0 U
0 D
1 L
1 D
2 D
2 R
2 U

*/