from collections import deque

def to(d):
    if d == "D":
        return "L"
    if d == "U":
        return "R"
    if d == "R":
        return "D"
    if d == "L":
        return "U"

n = int(input())

dir = {"U": deque(), "D": deque(), "L": deque(), "R": deque()}
moves = dict()

out = [0] * n

for i in range(n):
    a, b = input().split()
    a = int(a)
    if not a in moves:
        moves[a] = [(i, b)]
    else:
        moves[a].append((i, b))

for m in sorted(moves.keys()):
    for a in moves[m]:
        dir[a[1]].appendleft(a[0])
    for d in dir:
        if len(dir[d]) == 0 and len(dir[to(d)]) != 0:
            out[dir[to(d)].pop()] = m
    if len(dir["D"]) != 0 and len(dir["R"]) != 0 and len(dir["L"]) != 0 and len(dir["U"]) != 0:
        for d in dir:
            for i in dir[d]:
                out[i] = -1

for i in out:
    print(i)