import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;

public class K {
	String fileName = "i";
	
	long mod(long x) {
		return x % 1000000007;
	}
	
	public void solve() throws IOException {

		long M = 1000000000 + 7;
		long n = nextInt();
		long[] a = new long[32];
		
		long x = n + 1;
		for (int i = 0; i < 31; i++) {
			long w = x / ((1 << i) * 2) * (1 << i);
			long v = x % ((1 << i) * 2) - (1 << i);
			a[i] = w + Math.max(v, 0);
		}
		
		long sum = 0;
		for (int i = 0; i < 31; i++) {
			sum += mod(mod(a[i] * (n - a[i])) * (1 << i));
			sum = mod(sum);
		}
		
		System.out.println(sum);

	}

	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
//			 out = new PrintWriter(fileName + ".out");

			solve();

//			 out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new K().run();
	}

}
