#include <queue>
#include <iostream>
#include <vector>
#include <cstring>
#include <sstream>

using namespace std;

typedef long long ll;

int main() {
	freopen("input.txt", "r", stdin);
	int n;
	cin >> n;
	vector<int> t(n);
	vector<char> d(n);
	for (int i = 0; i < n; i++)
		cin >> t[i] >> d[i];
    
	queue<int> q[4];
	vector<int> ans(n, -1);
	bool rides[4] = {};

	int i = 0;
	int prev = 0;
	int now = 0;
	while (i < n) {
		bool allempty = true;
		bool allnempty = true;
		for (int i = 0; i < 4; i++) allempty &= q[i].empty(), allnempty &= !q[i].empty();

		if (i >= n && (allempty || allnempty))
			break;

		if (i < n && (allempty || allnempty))
			now = t[i];
		for (; i < n && t[i] == now; i++) {
			if (d[i] == 'U')
				q[0].push(i);
			else
				if (d[i] == 'L')
					q[1].push(i);
				else
					if (d[i] == 'D')
						q[2].push(i);
					else
						if (d[i] == 'R')
							q[3].push(i);
		}
		

		for (int j = 0; j < 4; j++)
			rides[j] = q[(j + 1) % 4].empty();
		for (int j = 0; j < 4; j++) {
			if (rides[j] && !q[j].empty()) {
				ans[q[j].front()] = now;
				q[j].pop();
			}
		}

		now++;
	}

	for (int i : ans) cout << i << '\n';


	return 0;
}