#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <sstream>

using namespace std;

typedef long long ll;

const int MAXN = 5e3 + 100;

bool dp[MAXN] = {};

int a[MAXN];
int b[MAXN][MAXN];

int main() {
	//freopen("input.txt", "r", stdin);
	int n; cin >> n;
	string s1, s2; cin >> s1 >> s2;

	for (int i = n - 1; i >= 0; i--)
		for (int j = n - 1; j >= 0; j--) {
		if (j != n - 1 && i != n - 1)
			b[i][j] = (b[i + 1][j + 1] + 1) * (s1[i] == s2[j]);
		else
			b[i][j] = (s1[i] == s2[j]);
		}

	dp[0] = true;
	for (int i = 1; i <= n; i++) {
		for (int j = 0; j < i; j++) {
			if (b[j][n - i] >= i - j)
				dp[i] = dp[j] || dp[i];
		}
	}

	if (dp[n])
		cout << "Yes" << endl;
	else
		cout << "No" << endl;

	return 0;
}