#include <bits/stdc++.h>
using namespace std;

bool used[201][201][201];
int from[201][201][201];
int dx[4] = {1, 0, -1, 0};
int dy[4] = {0, 1, 0, -1};
char dir[4] = {'D', 'R', 'U', 'L'};
string mas[201];
string s;
int n, m, l;

bool check(int x, int y, int q)
{
    return x >= 0 && x < n && y >= 0 && y < m && mas[x][y] == s[q];
}
string answer = "";
bool dfs(int x, int y, int q)
{
    used[x][y][q] = 1;
    int w = q + 1;
    if (w == l)
        w = 0;
    for (int i = 0; i < 4; i++)
    {
        if (check(x + dx[i], y + dy[i], w))
        {
            if (used[x + dx[i]][y + dy[i]][w] == 0)
            {
                from[x + dx[i]][y + dy[i]][w] = i;
                if (dfs(x + dx[i], y + dy[i], w))
                {
                    answer += dir[i];
                    return true;
                }
            }
            else if (used[x + dx[i]][y + dy[i]][w] == 1)
            {
                answer += dir[i];
                return true;
            }
        }
    }
    used[x][y][q] = 2;
    return false;
}

int main()
{
    //freopen("C.in", "r", stdin);
    //freopen("C.out", "w", stdout);
    iostream::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> l;
    for (int i = 0; i < n; i++)
    {
        cin >> mas[i];
    }
    cin >> s;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            if (mas[i][j] == s[0] && used[i][j][0] == 0 && dfs(i, j, 0))
            {
                cout << "YES" << endl << answer.size() << endl << i + 1 << " " << j + 1 << endl;
                for (int q = answer.size() - 1; q >= 0; q--)
                    cout << answer[q];
                cout << endl;
                return 0;
            }
        }
    }
    cout << "NO" << endl;
    return 0;
}
