#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <string>
#include <utility>
#include <queue>
#include <deque>
#include <stack>
#include <numeric>
#include <functional>
#include <cmath>
#include <iomanip>
using namespace std;
typedef long long ll;
typedef double db;
typedef vector<ll> vl;
typedef vector<vl> vvl;
typedef set<ll> sl;
typedef vector<string> vs;
typedef map<ll, ll> ml;
#define fi(i, n) for (ll i = 0; i < n; i++)
#define fie(i, s, f) for (ll i = s; i < f; i++)
#define fd(i, n) for (ll i = n - 1; i >= 0; i--)
#define fde(i, s, f) for (ll i = s; i >= f; i--)
#define sp setprecision
vl p, s;
ll n, m;
int main() {
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);
	cin.tie();
	cout.tie();
	cin >> n >> m;
	s.resize(n, 1);
	p.resize(n);
	fi(i, n) p[i] = i;
	ll a, b;
	vector<pair<ll, ll>> vpl;
	fi(i, m) {
		cin >> a >> b;
		a--; b--;
		vpl.push_back({ a, b });
	}
	ll l = 1, r = m + 1;
	vvl graph(n);
	vl deg(n);
	while (l < r - 1) {
		ll m = (l + r) / 2;
		fi(i, m) {
			graph[vpl[i].first].push_back(vpl[i].second);
			deg[vpl[i].second]++;
		}
		queue<ll> q;
		fi(i, n) {
			if (deg[i] == 0) q.push(i);
		}
		bool b = 1;
		while (!q.empty()) {
			if (q.size() != 1) {
				b = 0;
				break;
			}
			ll fr = q.front();
			q.pop();
			fi(i, graph[fr].size()) {
				ll to = graph[fr][i];
				deg[to]--;
				if (deg[to] == 0) q.push(to);
			}
		}
		if (b == 1) r = m;
		else l = m;
		fi(i, n) graph[i].clear();
	}
	if (r == m + 1) cout << "-1";
	else cout << r;
}