import java.util.*;

public class I1 {

	static int a[][];
	static boolean vis[];
	static int m;
	static int n;
	static ArrayList<Integer> t;

	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);

		n = in.nextInt();
		m = in.nextInt();
		a = new int[m][2];
		for (int i = 0; i < m; i++) {
			a[i][0] = in.nextInt() - 1;
			a[i][1] = in.nextInt() - 1;
		}

		int l = 0;
		int r = m + 1;
		while (r - l > 1) {
			int x = (r + l) / 2;
			if (isConn(x)) {
				r = x;
			} else {
				l = x;
			}
		}
		if (m < n - 1) {
			System.out.println(-1);
			return;
		}
		if ((l < m+1)&&isConn(l)) {
			System.out.println(l);
			return;
		}
		if ((r < m+1)&&isConn(r)) {
			System.out.println(r);
			return;
		}

		System.out.println(-1);
		
	}

	public static boolean isConn(int x) {
		ArrayList<Integer> g[] = new ArrayList[n];
		for (int i = 0; i < n; i++) {
			g[i] = new ArrayList<Integer>();
		}
		boolean p[] = new boolean[n];
		for (int i = 0; i < x; i++) {
			g[a[i][0]].add(a[i][1]);
			p[a[i][1]] = true;
		}

		vis = new boolean[n];
		t = new ArrayList<Integer>();

		for (int i = 0; i < n; i++) {
			if (!p[i]) {
				dfs(g, i);
				break;
			}
		}

		Collections.reverse(t);
		if (t.size() < n)
			return false;
		for (int i = 0; i < n - 1; i++) {
			if (!g[t.get(i)].contains(t.get(i + 1)))
				return false;
		}
		return true;
	}

	public static void dfs(ArrayList<Integer>[] g, int x) {
		vis[x] = true;
		for (int i = 0; i < g[x].size(); i++) {
			if (!vis[g[x].get(i)]) {
				dfs(g, g[x].get(i));
			}
		}
		t.add(x);
	}
}
