#include <vector>
#include <iostream>
#include <numeric>
#include <string>
#include <algorithm>

using namespace std;

const int p1 = 239;
//const int MOD1 = 1000000007;
//const int p2 = 101;
//const int MOD2 = 1000000009;

vector<long long> ps1, ps2, pt1, pt2;
vector<long long> pp1, pp2;

long long hs1(int L, int R) {
	long long ans = (ps1[R] - ps1[L] * pp1[R - L]);
	return ans;
}

//long long hs2(int L, int R) {
//	long long ans = (ps2[R] - ps2[L] * pp2[R - L]) % MOD2;
//	if (ans < 0)
//		ans += MOD2;
//	return ans;
//}

long long ht1(int L, int R) {
	long long ans = (pt1[R] - pt1[L] * pp1[R - L]);
	return ans;
}

//long long ht2(int L, int R) {
//	long long ans = (pt2[R] - pt2[L] * pp2[R - L]) % MOD2;
//	if (ans < 0)
//		ans += MOD2;
//	return ans;
//}

//long long hs(int L, int R) {
//	return (hs1(L, R)* MOD2) + hs2(L, R);
//}
//
//long long ht(int L, int R) {
//	return (ht1(L, R) * MOD2) + ht2(L, R);
//}

int main() {
	int n;
	cin >> n;
	string s, t;
	cin >> s >> t;

	vector<bool> dp(n + 1);
	dp[0] = true;

	pp1.resize(max(s.length(), t.length()) + 1);
	pp2.resize(max(s.length(), t.length()) + 1);
	pp1[0] = pp2[0] = 1;

	ps1.resize(s.length() + 1);
	ps2.resize(s.length() + 1);
	pt1.resize(t.length() + 1);
	pt2.resize(t.length() + 1);

	for (int i = 0; i < s.length(); i++) {
		ps1[i + 1] = (ps1[i] * p1 + s[i] - 'a' + 1);
		//ps2[i + 1] = (ps2[i] * p2 + s[i] - 'a' + 1) % MOD2;
		pp1[i + 1] = pp1[i] * p1;
		//pp2[i + 1] = pp2[i] * p2 % MOD2;
	}

	for (int i = 0; i < t.length(); i++) {
		pt1[i + 1] = (pt1[i] * p1 + t[i] - 'a' + 1);
		//pt2[i + 1] = (pt2[i] * p2 + t[i] - 'a' + 1) % MOD2;
		pp1[i + 1] = pp1[i] * p1;
		//pp2[i + 1] = pp2[i] * p2 % MOD2;
	}

	for (int L = 0; L < n; L++) {
		if (dp[L]) {
			for (int R = L + 1; R <= n; R++) {
				if (hs1(L, R) == ht1(n - R, n - L)) {
					dp[R] = true;
				}
			}
		}
	}

	if (dp[n]) {
		cout << "Yes" << endl;
	}
	else {
		cout << "No" << endl;
	}

	//system("pause");


	return 0;
}