#include <bits/stdc++.h>

using namespace std;

#define ll long long

const int maxN = 5010;

const ll mod = 3 + 1e9;
const ll p = 239;

ll st[maxN];

int dp[maxN];

int main()
{
    //freopen("in.in", "r", stdin);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    st[0] = 1;
    for(int i = 1; i <= n + 5; i++) st[i] = (st[i-1] * p)%mod;

    string s, t;
    cin >> s >> t;

    dp[0] = 1;
    for(int i = 1; i <= n; i++)
    {
        ll h1 = 0, h2 = 0;
        for(int k = 1; k <= i; k++)
        {
            h1 = (t[i - k] * st[k-1] + h1)%mod;
            h2 = (h2 * p + s[n - i + k - 1]) % mod;
            if(dp[i - k] && h1 == h2)
            {
                dp[i] = 1;
                break;
            }
        }
    }

    cout << (dp[n] ? "Yes" : "No") << endl;

    return 0;
}
