// CGSG forever

#define _CRT_SECURE_NO_WARNINGS

#include <cstdio>
#include <vector>
#include <cmath>

typedef __int64 INT64;

bool powof10( INT64 n )
{
  while (n != 1)
  {
    if (n % 10 == 0)
      n /= 10;
    else
      return false;
  }
  return true;
}

INT64 CountSum( INT64 n )
{
  if (n > 1 && n < 10)
    return 2;
  else if (n == 1)
    return 1;

  INT64 maxpow = 1, curnum = 1, arroundedsum = 1;

  // 577 ->- 1000 => maxpow = 3
  while ((curnum = curnum * 10) < n)
    maxpow++;

  // 577 => arroundedsum = 1000
  INT64 _10_pow_i = 1;
  for (int i = 2; i <= maxpow; i++)
  {
    arroundedsum += _10_pow_i * 9 * i;
    _10_pow_i *= 10;
  }
  _10_pow_i *= 10;

  INT64 sum = arroundedsum - (_10_pow_i - n) / 10 * maxpow + maxpow;

  if (powof10(n))
    return sum + 1;
  return sum;
}

int main( void )
{
  INT64 n;

  scanf("%I64D", &n);

  printf("%lli", CountSum(n));

  return 0;
}