#include <stdio.h>
#include <math.h>

int calcnums(__int64 steps, int addmp){
	__int64 tenps = 0, nums = 0;
	int tenp = 2;
	
	if (steps == 0){
		return 0;
	}

	if (steps < 10){
		return 1 + addmp;
	}

	if (steps < 100){
		return ((int)(steps / 10.0 + .95) * (2 + addmp));
	}
	
	while (pow(10.0, tenp) + tenps <= steps){
		nums += (tenp + addmp) * 9;
		tenps += pow(10.0, tenp);
		tenp++;
	}

	printf("%i\n", tenps);

	nums += tenp + addmp;
	int delta = steps - tenps;

	return nums + calcnums(delta, addmp + 1);
}




int calcInTier(int tier){
	int sum = tier;
	for (int i = 2; i <= tier; i++){
		sum = (sum) * 9 + i + 1;
	}
	if (sum == 1)
		sum = 0;
	return sum;
}

int ilog10(__int64 n){
	int t = 0;
	while (n >= 10){
		n /= 10;
		t++;
	}
	return t;
}

__int64 ipow10(__int64 n){
	__int64 t = 1;
	while (n >= 10){
		n /= 10;
		t *= 10;
	}
	if (t < 100){
		return 0;
	}
	return t;
}

int calcnums2(__int64 steps){
	int tier = ilog10(steps);
	int intier = calcInTier(tier);
	int delta = steps - ipow10(steps);
	int outtier = (tier + 1) * ((int)(delta / 10));
	if (delta % 10 > 0)
		outtier += tier + 1;
	return intier + outtier;
}




int main(void){
	__int64 steps, tenps = 0, nums = 0;
	int tenp = 2;
	scanf("%lld", &steps);

	nums++;
	printf("%i\n", calcnums2(steps) + 1);


	return 0;
}

/*
int countNum(int num){
	int c = 0;
	while (num > 0){
		num /= 10;
		c++;
	}
	return c;
}

int main(void){
	__int64 prize = 100;
	int n;
	scanf("%i", &n);

	n--;
	printf("100\n");
	for (int i = 0; i < n; i++){
		prize *= 2;
		int nulls = countNum(prize);
		nulls = (nulls / 2.0 + .5);
		int d = (int)pow(10.0, nulls);
		if (prize % d != 0){
			prize += d - prize % d;
		}
		printf("%i\n", prize);
	}

	return 0;
}
*/