#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MAX_N = 1e5 + 1;

vector<vector<int> > r(MAX_N);
int n, m;
int kol[MAX_N];
pair<int, int> v[MAX_N];

bool check(int k)
{
    r.clear();
    r.resize(MAX_N);
    unordered_set<ll> re;
    memset(kol, 0, sizeof(kol));
    for (int i = 0; i < k; i++)
    {
        r[v[i].first].push_back(v[i].second);
        kol[v[i].second]++;
        re.insert(((ll)(v[i].first) << 32) | (ll)(v[i].second));
    }
    //for (int i = 0; i < n; i++)
    //    cerr << kol[i] << endl;
    set<pair<int, int> > q;
    for (int i = 0; i < n; i++)
        q.insert(make_pair(kol[i], i));
    vector<int> p;
    for (int i = 0; i < n; i++)
    {
        int now = q.begin()->second;
        //cerr << now << endl;
        p.push_back(now);
        if (kol[now] != 0)
            return false;
        q.erase(q.begin());
        for (int j : r[now])
        {
            q.erase(make_pair(kol[j], j));
            kol[j]--;
            q.insert(make_pair(kol[j], j));
        }
    }
    for (int i = 0; i < p.size() - 1; i++)
        if (re.count(((ll)(p[i]) << 32) | (ll)(p[i + 1])) == 0)
            return false;
    return true;
}

int main()
{
    //freopen("test.in", "r", stdin);
    cin.sync_with_stdio(0);
    cin >> n >> m;
    int l = 0;
    int r = m + 1;
    for (int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--, b--;
        v[i] = (make_pair(a, b));
    }
    while (r - l > 1)
    {
        int h = (l + r) / 2;
        vector<pair<int, int> > now;
        for (int i = 0; i < h; i++)
            now.push_back(v[i]);
        if (check(h))
            r = h;
        else
            l = h;
    }
    if (r == m + 1)
    {
        cout << -1;
        return 0;
    }
    cout << r;
    return 0;
}
