#include <iostream>
#include <cmath>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <cstring>

using namespace std;

const int S = 1000000007;

long long kek(long long x){
    return ((x % S) + S) % S;
}

int main()
{
    int n;
    cin >> n;
    long long nulls[31], ones[31], pow[31];
    pow[0] = 1;
    for(int i = 0; i < 31; i++)
    {
        nulls[i] = 0;
        ones[i] = 0;
    }
    for(int i = 1; i < 31; i++)
        pow[i] = 2 * pow[i - 1];
    for(int i = 0; i < 31; i++)
    {
        long long k = n - pow[i] + 1;
        if (k <= 0) {
            continue;
        }
        nulls[i] += pow[i] - 1;
        nulls[i] += (k / (pow[i] * 2)) * pow[i];
        ones[i] += (k / (pow[i] * 2)) * pow[i];
        if (k % (pow[i] * 2) <= pow[i])
            ones[i] += k % (pow[i] * 2);
        else
        {
            ones[i] += pow[i];
            nulls[i] += k % (pow[i] * 2) - pow[i];
        }
    }
    long long ans = 0;
    for(int i = 0; i < 31; i++)
        ans = kek(ans + kek(nulls[i] * kek(ones[i] * pow[i])));
    cout << ans << endl;
    return 0;
}
