import java.io.*;
import java.util.Locale;
import java.util.StringTokenizer;

public class D {

    public void solve() throws IOException {
        long n = nextLong();
        if (n == 1) {
            out.print(1);
        } else {
            long i = 1;
            long ans = 0;
            while (i < Long.toString(n).length() - 1) {
                ans += ((i + 1) * (9 * Math.pow(10, (i - 1))));
                i += 1;
            }
            for (int j = (int) Math.pow(10, i); j < n; j++) {
                if (j % 10 == 0)
                    ans += i + 1;
            }
            out.print(ans + 1 + Long.toString(n).length());
        }
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new D().run();
    }

}
